Index: src/includes/classes/Smarty/sysplugins/smarty_internal_templatecompilerbase.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_templatecompilerbase.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_templatecompilerbase.php	(revision )
@@ -14,15 +14,35 @@
  *
  * @package    Smarty
  * @subpackage Compiler
+ *
+ * @property Smarty_Internal_SmartyTemplateCompiler $prefixCompiledCode  = ''
+ * @property Smarty_Internal_SmartyTemplateCompiler $postfixCompiledCode = ''
+ * @method Smarty_Internal_SmartyTemplateCompiler registerPostCompileCallback($callback, $parameter = array(), $key = null, $replace = false)
+ * @method Smarty_Internal_SmartyTemplateCompiler unregisterPostCompileCallback($key)
  */
 abstract class Smarty_Internal_TemplateCompilerBase
 {
+
     /**
+     * Smarty object
+     *
+     * @var Smarty
+     */
+    public $smarty = null;
+
+    /**
+     * Parser object
+     *
+     * @var Smarty_Internal_Templateparser
+     */
+    public $parser = null;
+
+    /**
      * hash for nocache sections
      *
      * @var mixed
      */
-    private $nocache_hash = null;
+    public $nocache_hash = null;
 
     /**
      * suppress generation of nocache code
@@ -32,18 +52,11 @@
     public $suppressNocacheProcessing = false;
 
     /**
-     * suppress generation of merged template code
+     * compile tag objects cache
      *
-     * @var bool
-     */
-    public $suppressMergedTemplates = false;
-
-    /**
-     * compile tag objects
-     *
      * @var array
      */
-    public static $_tag_objects = array();
+    public $_tag_objects = array();
 
     /**
      * tag stack
@@ -60,39 +73,25 @@
     public $template = null;
 
     /**
-     * merged templates
+     * merged included sub template data
      *
      * @var array
      */
-    public $merged_templates = array();
+    public $mergedSubTemplatesData = array();
 
     /**
-     * sources which must be compiled
+     * merged sub template code
      *
      * @var array
      */
-    public $sources = array();
+    public $mergedSubTemplatesCode = array();
 
     /**
-     * flag that we are inside {block}
+     * collected template properties during compilation
      *
-     * @var bool
-     */
-    public $inheritance = false;
-
-    /**
-     * flag when compiling inheritance child template
-     *
-     * @var bool
-     */
-    public $inheritance_child = false;
-
-    /**
-     * uid of templates called by {extends} for recursion check
-     *
      * @var array
      */
-    public $extends_uid = array();
+    public $templateProperties = array();
 
     /**
      * source line offset for error messages
@@ -114,6 +113,7 @@
      * @var string
      */
     public $trace_filepath = '';
+
     /**
      * stack for tracing file and line of nested {block} tags
      *
@@ -143,184 +143,324 @@
     public $forceNocache = false;
 
     /**
-     * suppress Smarty header code in compiled template
+     * flag if compiled template file shall we written
      *
      * @var bool
      */
-    public $suppressHeader = false;
+    public $write_compiled_code = true;
 
     /**
-     * suppress template property header code in compiled template
+     * Template functions
      *
+     * @var array
+     */
+    public $tpl_function = array();
+
+    /**
+     * called sub functions from template function
+     *
+     * @var array
+     */
+    public $called_functions = array();
+
+    /**
+     * compiled template or block function code
+     *
+     * @var string
+     */
+    public $blockOrFunctionCode = '';
+
+    /**
+     * php_handling setting either from Smarty or security
+     *
+     * @var int
+     */
+    public $php_handling = 0;
+
+    /**
+     * flags for used modifier plugins
+     *
+     * @var array
+     */
+    public $modifier_plugins = array();
+
+    /**
+     * type of already compiled modifier
+     *
+     * @var array
+     */
+    public $known_modifier_type = array();
+
+    /**
+     * parent compiler object for merged subtemplates and template functions
+     *
+     * @var Smarty_Internal_TemplateCompilerBase
+     */
+    public $parent_compiler = null;
+
+    /**
+     * Flag true when compiling nocache section
+     *
      * @var bool
      */
-    public $suppressTemplatePropertyHeader = false;
+    public $nocache = false;
 
     /**
-     * suppress pre and post filter
+     * Flag true when tag is compiled as nocache
      *
      * @var bool
      */
-    public $suppressFilter = false;
+    public $tag_nocache = false;
 
     /**
-     * flag if compiled template file shall we written
+     * Compiled tag prefix code
      *
+     * @var array
+     */
+    public $prefix_code = array();
+
+    /**
+     * Prefix code  stack
+     *
+     * @var array
+     */
+    public $prefixCodeStack = array();
+
+    /**
+     * Tag has compiled code
+     *
      * @var bool
      */
-    public $write_compiled_code = true;
+    public $has_code = false;
 
     /**
-     * flag if currently a template function is compiled
+     * A variable string was compiled
      *
      * @var bool
      */
-    public $compiles_template_function = false;
+    public $has_variable_string = false;
 
     /**
-     * called subfuntions from template function
+     * Tag creates output
      *
+     * @var bool
+     */
+    public $has_output = false;
+
+    /**
+     * Stack for {setfilter} {/setfilter}
+     *
      * @var array
      */
-    public $called_functions = array();
+    public $variable_filter_stack = array();
 
     /**
-     * flags for used modifier plugins
+     * variable filters for {setfilter} {/setfilter}
      *
      * @var array
      */
-    public $modifier_plugins = array();
+    public $variable_filters = array();
 
     /**
-     * type of already compiled modifier
+     * Nesting count of looping tags like {foreach}, {for}, {section}, {while}
      *
+     * @var int
+     */
+    public $loopNesting = 0;
+
+    /**
+     * Strip preg pattern
+     *
+     * @var string
+     */
+    public $stripRegEx = '![\t ]*[\r\n]+[\t ]*!';
+
+    /**
+     * plugin search order
+     *
      * @var array
      */
-    public $known_modifier_type = array();
+    public $plugin_search_order = array('function', 'block', 'compiler', 'class');
 
     /**
+     * General storage area for tag compiler plugins
+     *
+     * @var array
+     */
+    public $_cache = array();
+
+    /**
      * method to compile a Smarty template
      *
-     * @param  mixed $_content template source
+     * @param mixed $_content template source
+     * @param bool  $isTemplateSource
      *
-     * @return bool  true if compiling succeeded, false if it failed
+     * @return bool true if compiling succeeded, false if it failed
      */
-    abstract protected function doCompile($_content);
+    abstract protected function doCompile($_content, $isTemplateSource = false);
 
     /**
      * Initialize compiler
+     *
+     * @param Smarty $smarty global instance
      */
-    public function __construct()
+    public function __construct(Smarty $smarty)
     {
-        $this->nocache_hash = str_replace(array('.', ','), '-', uniqid(rand(), true));
+        $this->smarty = $smarty;
+        $this->nocache_hash = str_replace(array('.', ','), '_', uniqid(rand(), true));
     }
 
     /**
      * Method to compile a Smarty template
      *
-     * @param  Smarty_Internal_Template $template template object to compile
+     * @param  Smarty_Internal_Template                 $template template object to compile
-     * @param  bool                     $nocache  true is shall be compiled in nocache mode
+     * @param  bool                                     $nocache  true is shall be compiled in nocache mode
+     * @param null|Smarty_Internal_TemplateCompilerBase $parent_compiler
      *
-     * @return bool             true if compiling succeeded, false if it failed
+     * @return bool true if compiling succeeded, false if it failed
+     * @throws \Exception
      */
-    public function compileTemplate(Smarty_Internal_Template $template, $nocache = false)
+    public function compileTemplate(Smarty_Internal_Template $template, $nocache = null,
+                                    Smarty_Internal_TemplateCompilerBase $parent_compiler = null)
     {
-        if (empty($template->properties['nocache_hash'])) {
-            $template->properties['nocache_hash'] = $this->nocache_hash;
-        } else {
-            $this->nocache_hash = $template->properties['nocache_hash'];
+        // get code frame of compiled template
+        $_compiled_code = $template->smarty->ext->_codeFrame->create($template,
+                                                                     $this->compileTemplateSource($template, $nocache,
+                                                                                                  $parent_compiler),
+                                                                     $this->postFilter($this->blockOrFunctionCode) .
+                                                                     join('', $this->mergedSubTemplatesCode), false,
+                                                                     $this);
+        return $_compiled_code;
-        }
+    }
-        // flag for nochache sections
-        $this->nocache = $nocache;
-        $this->tag_nocache = false;
+
+    /**
+     * Compile template source and run optional post filter
+     *
+     * @param \Smarty_Internal_Template             $template
+     * @param null|bool                             $nocache flag if template must be compiled in nocache mode
+     * @param \Smarty_Internal_TemplateCompilerBase $parent_compiler
+     *
+     * @return string
+     * @throws \Exception
+     */
+    public function compileTemplateSource(Smarty_Internal_Template $template, $nocache = null,
+                                          Smarty_Internal_TemplateCompilerBase $parent_compiler = null)
+    {
+        try {
-        // save template object in compiler class
-        $this->template = $template;
+            // save template object in compiler class
+            $this->template = $template;
-        // reset has nocache code flag
-        $this->template->has_nocache_code = false;
-        $save_source = $this->template->source;
-        // template header code
-        $template_header = '';
-        if (!$this->suppressHeader) {
-            $template_header .= "<?php /* Smarty version " . Smarty::SMARTY_VERSION . ", created on " . strftime("%Y-%m-%d %H:%M:%S") . "\n";
-            $template_header .= "         compiled from \"" . $this->template->source->filepath . "\" */ ?>\n";
+            if (property_exists($this->template->smarty, 'plugin_search_order')) {
+                $this->plugin_search_order = $this->template->smarty->plugin_search_order;
-        }
+            }
-
-        if (empty($this->template->source->components)) {
-            $this->sources = array($template->source);
-        } else {
-            // we have array of inheritance templates by extends: resource
-            $this->sources = array_reverse($template->source->components);
-        }
-        $loop = 0;
-        // the $this->sources array can get additional elements while compiling by the {extends} tag
-        while ($this->template->source = array_shift($this->sources)) {
-            $this->smarty->_current_file = $this->template->source->filepath;
             if ($this->smarty->debugging) {
-                Smarty_Internal_Debug::start_compile($this->template);
+                $this->smarty->_debug->start_compile($this->template);
             }
-            $no_sources = count($this->sources);
-            if ($loop || $no_sources) {
-                $this->template->properties['file_dependency'][$this->template->source->uid] = array($this->template->source->filepath, $this->template->source->timestamp, $this->template->source->type);
+            if (isset($this->template->smarty->security_policy)) {
+                $this->php_handling = $this->template->smarty->security_policy->php_handling;
+            } else {
+                $this->php_handling = $this->template->smarty->php_handling;
             }
-            $loop ++;
-            if ($no_sources) {
-                $this->inheritance_child = true;
+            $this->parent_compiler = $parent_compiler ? $parent_compiler : $this;
+            $nocache = isset($nocache) ? $nocache : false;
+            if (empty($template->compiled->nocache_hash)) {
+                $template->compiled->nocache_hash = $this->nocache_hash;
             } else {
-                $this->inheritance_child = false;
+                $this->nocache_hash = $template->compiled->nocache_hash;
             }
-            do {
-                $_compiled_code = '';
-                // flag for aborting current and start recompile
-                $this->abort_and_recompile = false;
+            // flag for nocache sections
+            $this->nocache = $nocache;
+            $this->tag_nocache = false;
+            // reset has nocache code flag
+            $this->template->compiled->has_nocache_code = false;
+            $this->has_variable_string = false;
+            $this->prefix_code = array();
+            // add file dependency
+            $this->parent_compiler->template->compiled->file_dependency[ $this->template->source->uid ] =
+                array($this->template->source->filepath, $this->template->source->getTimeStamp(),
+                      $this->template->source->type);
+            $this->smarty->_current_file = $this->template->source->filepath;
-                // get template source
+            // get template source
-                $_content = $this->template->source->content;
-                if ($_content != '') {
-                    // run prefilter if required
-                    if ((isset($this->smarty->autoload_filters['pre']) || isset($this->smarty->registered_filters['pre'])) && !$this->suppressFilter) {
-                        $_content = Smarty_Internal_Filter_Handler::runFilter('pre', $_content, $template);
+            if (!empty($this->template->source->components)) {
+                // we have array of inheritance templates by extends: resource
+                // generate corresponding source code sequence
+                $_content =
+                    Smarty_Internal_Compile_Extends::extendsSourceArrayCode($this->template->source->components);
+            } else {
+                // get template source
+                $_content = $this->template->source->getContent();
-                    }
+            }
-                    // call compiler
-                    $_compiled_code = $this->doCompile($_content);
+            $_compiled_code = $this->postFilter($this->doCompile($this->preFilter($_content), true));
-                }
+        }
-            } while ($this->abort_and_recompile);
+        catch (Exception $e) {
             if ($this->smarty->debugging) {
-                Smarty_Internal_Debug::end_compile($this->template);
+                $this->smarty->_debug->end_compile($this->template);
             }
-        }
-        // restore source
-        $this->template->source = $save_source;
-        unset($save_source);
-        $this->smarty->_current_file = $this->template->source->filepath;
+            $this->_tag_stack = array();
+            $this->_tag_objects = array();
-        // free memory
+            // free memory
-        unset($this->parser->root_buffer, $this->parser->current_buffer, $this->parser, $this->lex, $this->template);
-        self::$_tag_objects = array();
-        // return compiled code to template object
-        $merged_code = '';
-        if (!$this->suppressMergedTemplates && !empty($this->merged_templates)) {
-            foreach ($this->merged_templates as $code) {
-                $merged_code .= $code;
+            $this->parent_compiler = null;
+            $this->template = null;
+            $this->parser = null;
+            throw $e;
-            }
+        }
+        if ($this->smarty->debugging) {
+            $this->smarty->_debug->end_compile($this->template);
         }
-        // run postfilter if required on compiled template code
-        if ((isset($this->smarty->autoload_filters['post']) || isset($this->smarty->registered_filters['post'])) && !$this->suppressFilter && $_compiled_code != '') {
-            $_compiled_code = Smarty_Internal_Filter_Handler::runFilter('post', $_compiled_code, $template);
+        $this->parent_compiler = null;
+        $this->template = null;
+        $this->parser = null;
+        return $_compiled_code;
-        }
+    }
-        if ($this->suppressTemplatePropertyHeader) {
-            $code = $_compiled_code . $merged_code;
+
+    /**
+     * Optionally process compiled code by post filter
+     *
+     * @param string $code compiled code
+     *
+     * @return string
+     * @throws \SmartyException
+     */
+    public function postFilter($code)
+    {
+        // run post filter if on code
+        if (!empty($code) &&
+            (isset($this->smarty->autoload_filters[ 'post' ]) || isset($this->smarty->registered_filters[ 'post' ]))
+        ) {
+            return $this->smarty->ext->_filterHandler->runFilter('post', $code, $this->template);
         } else {
-            $code = $template_header . $template->createTemplateCodeFrame($_compiled_code) . $merged_code;
+            return $code;
         }
-        // unset content because template inheritance could have replace source with parent code
-        unset ($template->source->content);
+    }
 
-        return $code;
+    /**
+     * Run optional prefilter
+     *
+     * @param string $_content template source
+     *
+     * @return string
+     * @throws \SmartyException
+     */
+    public function preFilter($_content)
+    {
+        // run pre filter if required
+        if ($_content != '' &&
+            ((isset($this->smarty->autoload_filters[ 'pre' ]) || isset($this->smarty->registered_filters[ 'pre' ])))
+        ) {
+            return $this->smarty->ext->_filterHandler->runFilter('pre', $_content, $this->template);
+        } else {
+            return $_content;
-    }
+        }
+    }
 
     /**
      * Compile Tag
      * This is a call back from the lexer/parser
-     * It executes the required compile plugin for the Smarty tag
      *
+     * Save current prefix code
+     * Compile tag
+     * Merge tag prefix code with saved one
+     * (required nested tags in attributes)
+     *
      * @param  string $tag       tag name
      * @param  array  $args      array with tag attributes
      * @param  array  $parameter array with compilation parameter
@@ -331,25 +471,46 @@
      */
     public function compileTag($tag, $args, $parameter = array())
     {
+        $this->prefixCodeStack[] = $this->prefix_code;
+        $this->prefix_code = array();
+        $result = $this->compileTag2($tag, $args, $parameter);
+        $this->prefix_code = array_merge($this->prefix_code, array_pop($this->prefixCodeStack));
+        return $result;
+    }
+
+    /**
+     * Compile Tag
+     *
+     * @param  string $tag       tag name
+     * @param  array  $args      array with tag attributes
+     * @param  array  $parameter array with compilation parameter
+     *
+     * @throws SmartyCompilerException
+     * @throws SmartyException
+     * @return string compiled code
+     */
+    private function compileTag2($tag, $args, $parameter)
+    {
+        $plugin_type = '';
         // $args contains the attributes parsed and compiled by the lexer/parser
         // assume that tag does compile into code, but creates no HTML output
         $this->has_code = true;
         $this->has_output = false;
         // log tag/attributes
-        if (isset($this->smarty->get_used_tags) && $this->smarty->get_used_tags) {
-            $this->template->used_tags[] = array($tag, $args);
+        if (isset($this->smarty->_cache[ 'get_used_tags' ])) {
+            $this->template->_cache[ 'used_tags' ][] = array($tag, $args);
         }
         // check nocache option flag
-        if (in_array("'nocache'", $args) || in_array(array('nocache' => 'true'), $args)
-            || in_array(array('nocache' => '"true"'), $args) || in_array(array('nocache' => "'true'"), $args)
+        if (in_array("'nocache'", $args) || in_array(array('nocache' => 'true'), $args) ||
+            in_array(array('nocache' => '"true"'), $args) || in_array(array('nocache' => "'true'"), $args)
         ) {
             $this->tag_nocache = true;
         }
-        // compile the smarty tag (required compile classes to compile the tag are autoloaded)
+        // compile the smarty tag (required compile classes to compile the tag are auto loaded)
         if (($_output = $this->callTagCompiler($tag, $args, $parameter)) === false) {
-            if (isset($this->smarty->template_functions[$tag])) {
+            if (isset($this->parent_compiler->template->tpl_function[ $tag ])) {
                 // template defined by {template} tag
-                $args['_attr']['name'] = "'" . $tag . "'";
+                $args[ '_attr' ][ 'name' ] = "'" . $tag . "'";
                 $_output = $this->callTagCompiler('call', $args, $parameter);
             }
         }
@@ -369,8 +530,8 @@
             return null;
         } else {
             // map_named attributes
-            if (isset($args['_attr'])) {
+            if (isset($args[ '_attr' ])) {
-                foreach ($args['_attr'] as $key => $attribute) {
+                foreach ($args[ '_attr' ] as $key => $attribute) {
                     if (is_array($attribute)) {
                         $args = array_merge($args, $attribute);
                     }
@@ -379,22 +540,26 @@
             // not an internal compiler tag
             if (strlen($tag) < 6 || substr($tag, - 5) != 'close') {
                 // check if tag is a registered object
-                if (isset($this->smarty->registered_objects[$tag]) && isset($parameter['object_method'])) {
+                if (isset($this->smarty->registered_objects[ $tag ]) && isset($parameter[ 'object_method' ])) {
-                    $method = $parameter['object_method'];
+                    $method = $parameter[ 'object_method' ];
-                    if (!in_array($method, $this->smarty->registered_objects[$tag][3]) &&
+                    if (!in_array($method, $this->smarty->registered_objects[ $tag ][ 3 ]) &&
-                        (empty($this->smarty->registered_objects[$tag][1]) || in_array($method, $this->smarty->registered_objects[$tag][1]))
+                        (empty($this->smarty->registered_objects[ $tag ][ 1 ]) ||
+                            in_array($method, $this->smarty->registered_objects[ $tag ][ 1 ]))
                     ) {
                         return $this->callTagCompiler('private_object_function', $args, $parameter, $tag, $method);
-                    } elseif (in_array($method, $this->smarty->registered_objects[$tag][3])) {
+                    } elseif (in_array($method, $this->smarty->registered_objects[ $tag ][ 3 ])) {
-                        return $this->callTagCompiler('private_object_block_function', $args, $parameter, $tag, $method);
+                        return $this->callTagCompiler('private_object_block_function', $args, $parameter, $tag,
+                                                      $method);
                     } else {
                         // throw exception
-                        $this->trigger_template_error('not allowed method "' . $method . '" in registered object "' . $tag . '"', $this->lex->taglineno);
+                        $this->trigger_template_error('not allowed method "' . $method . '" in registered object "' .
+                                                      $tag . '"', null, true);
                     }
                 }
                 // check if tag is registered
-                foreach (array(Smarty::PLUGIN_COMPILER, Smarty::PLUGIN_FUNCTION, Smarty::PLUGIN_BLOCK) as $plugin_type) {
+                foreach (array(Smarty::PLUGIN_COMPILER, Smarty::PLUGIN_FUNCTION, Smarty::PLUGIN_BLOCK) as $plugin_type)
+                {
-                    if (isset($this->smarty->registered_plugins[$plugin_type][$tag])) {
+                    if (isset($this->smarty->registered_plugins[ $plugin_type ][ $tag ])) {
                         // if compiler function plugin call it now
                         if ($plugin_type == Smarty::PLUGIN_COMPILER) {
                             $new_args = array();
@@ -402,30 +567,36 @@
                                 if (is_array($mixed)) {
                                     $new_args = array_merge($new_args, $mixed);
                                 } else {
-                                    $new_args[$key] = $mixed;
+                                    $new_args[ $key ] = $mixed;
                                 }
                             }
-                            if (!$this->smarty->registered_plugins[$plugin_type][$tag][1]) {
+                            if (!$this->smarty->registered_plugins[ $plugin_type ][ $tag ][ 1 ]) {
                                 $this->tag_nocache = true;
                             }
-                            $function = $this->smarty->registered_plugins[$plugin_type][$tag][0];
+                            $function = $this->smarty->registered_plugins[ $plugin_type ][ $tag ][ 0 ];
                             if (!is_array($function)) {
                                 return $function($new_args, $this);
-                            } elseif (is_object($function[0])) {
+                            } elseif (is_object($function[ 0 ])) {
-                                return $this->smarty->registered_plugins[$plugin_type][$tag][0][0]->$function[1]($new_args, $this);
+                                return $this->smarty->registered_plugins[ $plugin_type ][ $tag ][ 0 ][ 0 ]->{$function[ 1 ]}($new_args,
+                                                                                                                             $this);
                             } else {
                                 return call_user_func_array($function, array($new_args, $this));
                             }
                         }
                         // compile registered function or block function
                         if ($plugin_type == Smarty::PLUGIN_FUNCTION || $plugin_type == Smarty::PLUGIN_BLOCK) {
-                            return $this->callTagCompiler('private_registered_' . $plugin_type, $args, $parameter, $tag);
+                            return $this->callTagCompiler('private_registered_' . $plugin_type, $args, $parameter,
+                                                          $tag);
                         }
                     }
                 }
                 // check plugins from plugins folder
-                foreach ($this->smarty->plugin_search_order as $plugin_type) {
-                    if ($plugin_type == Smarty::PLUGIN_COMPILER && $this->smarty->loadPlugin('smarty_compiler_' . $tag) && (!isset($this->smarty->security_policy) || $this->smarty->security_policy->isTrustedTag($tag, $this))) {
+                foreach ($this->plugin_search_order as $plugin_type) {
+                    if ($plugin_type == Smarty::PLUGIN_COMPILER &&
+                        $this->smarty->loadPlugin('smarty_compiler_' . $tag) &&
+                        (!isset($this->smarty->security_policy) ||
+                            $this->smarty->security_policy->isTrustedTag($tag, $this))
+                    ) {
                         $plugin = 'smarty_compiler_' . $tag;
                         if (is_callable($plugin)) {
                             // convert arguments format for old compiler plugins
@@ -434,7 +605,7 @@
                                 if (is_array($mixed)) {
                                     $new_args = array_merge($new_args, $mixed);
                                 } else {
-                                    $new_args[$key] = $mixed;
+                                    $new_args[ $key ] = $mixed;
                                 }
                             }
 
@@ -449,8 +620,11 @@
                         throw new SmartyException("Plugin \"{$tag}\" not callable");
                     } else {
                         if ($function = $this->getPlugin($tag, $plugin_type)) {
-                            if (!isset($this->smarty->security_policy) || $this->smarty->security_policy->isTrustedTag($tag, $this)) {
-                                return $this->callTagCompiler('private_' . $plugin_type . '_plugin', $args, $parameter, $tag, $function);
+                            if (!isset($this->smarty->security_policy) ||
+                                $this->smarty->security_policy->isTrustedTag($tag, $this)
+                            ) {
+                                return $this->callTagCompiler('private_' . $plugin_type . '_plugin', $args, $parameter,
+                                                              $tag, $function);
                             }
                         }
                     }
@@ -458,15 +632,15 @@
                 if (is_callable($this->smarty->default_plugin_handler_func)) {
                     $found = false;
                     // look for already resolved tags
-                    foreach ($this->smarty->plugin_search_order as $plugin_type) {
+                    foreach ($this->plugin_search_order as $plugin_type) {
-                        if (isset($this->default_handler_plugins[$plugin_type][$tag])) {
+                        if (isset($this->default_handler_plugins[ $plugin_type ][ $tag ])) {
                             $found = true;
                             break;
                         }
                     }
                     if (!$found) {
                         // call default handler
-                        foreach ($this->smarty->plugin_search_order as $plugin_type) {
+                        foreach ($this->plugin_search_order as $plugin_type) {
                             if ($this->getPluginFromDefaultHandler($tag, $plugin_type)) {
                                 $found = true;
                                 break;
